local require = GLOBAL.require
local SpawnPrefab = GLOBAL.SpawnPrefab
--
require "class"

local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
        TECH = GLOBAL.TECH


PrefabFiles = {

	"pumpkin_lord",
}

local assets=
{

	Asset("ATLAS", "images/inventoryimages/pumpkin_lord.xml"),
	Asset("IMAGE", "images/inventoryimages/pumpkin_lord.tex"),	
}

AddMinimapAtlas("images/inventoryimages/pumpkin_lord.xml")


local pumpkin_lordrecipe = GLOBAL.Recipe( ("pumpkin_lord"), { Ingredient("redgem", 1),Ingredient("cutgrass", 20),Ingredient("pumpkin_lantern", 1) }, RECIPETABS.WAR,  {SCIENCE = 2} )
pumpkin_lordrecipe.atlas = "images/inventoryimages/pumpkin_lord.xml"

STRINGS.ACTIONS.SITCOMMAND = "Order to Stay"
STRINGS.ACTIONS.SITCOMMAND_CANCEL = "Order to Follow"

STRINGS.CHARACTERS.GENERIC.ANNOUNCE_SITCOMMAND = "Stay!"
STRINGS.CHARACTERS.GENERIC.ANNOUNCE_SITCOMMAND_CANCEL = "Come to me!"
STRINGS.CHARACTERS.WX78.ANNOUNCE_SITCOMMAND = "STAY"
STRINGS.CHARACTERS.WX78.ANNOUNCE_SITCOMMAND_CANCEL = "FOLLOW"	

function teleporterpostinit(inst)

	inst.Activate = function(self, doer)
	--begin core
		if self.targetTeleporter == nil then
			return
		end
		
		if self.onActivate then
			self.onActivate(self.inst, doer)
		end

		if self.onActivateOther then
			self.onActivateOther(self.inst, self.targetTeleporter, doer)
		end
		
		
		self:Teleport(doer)
		
		if doer.components.leader then
			for follower,v in pairs(doer.components.leader.followers) do
				if not follower.components.unteleportable then
					self:Teleport(follower)
				end
			end
		end
		
		--special case for the chester_eyebone: look for inventory items with followers
		if doer.components.inventory then
			
			for k,item in pairs(doer.components.inventory.itemslots) do
				if item.components.leader then
					for follower,v in pairs(item.components.leader.followers) do
						self:Teleport(follower)
					end
				end
			end
			
			for k,equipped in pairs(doer.components.inventory.equipslots) do
				if equipped and equipped.components.container then
					local container = equipped.components.container
					for j,item in pairs(container.slots) do
						if item.components.leader then
							for follower,v in pairs(item.components.leader.followers) do
								self:Teleport(follower)
							end
						end
					end
				end
			end
			
		end
	-- end core
	end

end

AddComponentPostInit("teleporter", teleporterpostinit)
	
-- overwrite getsavefollowers to ignore followers with unteleportable
GLOBAL.SaveIndex.GetSaveFollowers = function (self, doer)
	local followers = {}

	if doer.components.leader then
		for follower,v in pairs(doer.components.leader.followers) do
			if follower.components.followersitcommand and follower.components.followersitcommand.stay == false then
				local ent_data = follower:GetPersistData()
				table.insert(followers, {prefab = follower.prefab, data = follower:GetPersistData()})
				follower:Remove()
			elseif not follower.components.followersitcommand and not follower.components.unteleportable then
				local ent_data = follower:GetPersistData()
				table.insert(followers, {prefab = follower.prefab, data = follower:GetPersistData()})
				follower:Remove()
			end
		end
	end

	--special case for the chester_eyebone: look for inventory items with followers
	if doer.components.inventory then
		for k,item in pairs(doer.components.inventory.itemslots) do
			if item.components.leader then
				for follower,v in pairs(item.components.leader.followers) do
					local ent_data = follower:GetPersistData()
					table.insert(followers, {prefab = follower.prefab, data = follower:GetPersistData()})
					follower:Remove()
				end
			end
		end

		-- special special case, look inside equipped containers
		for k,equipped in pairs(doer.components.inventory.equipslots) do
			if equipped and equipped.components.container then
				local container = equipped.components.container
				for j,item in pairs(container.slots) do
					if item.components.leader then
						for follower,v in pairs(item.components.leader.followers) do
							local ent_data = follower:GetPersistData()
							table.insert(followers, {prefab = follower.prefab, data = follower:GetPersistData()})
							follower:Remove()
						end
					end
				end
			end
		end
	end

	if self.data~= nil and self.data.slots ~= nil and self.data.slots[self.current_slot] ~= nil then
	 	self.data.slots[self.current_slot].followers = followers
	end	
end


	
ACTIONS.SITCOMMAND = GLOBAL.Action(2, true, true)
ACTIONS.SITCOMMAND.fn = function(act)
	local targ = act.target
	if targ and targ.components.followersitcommand then
		act.doer.components.locomotor:Stop()
		act.doer.components.talker:Say(GLOBAL.GetString(act.doer.prefab, "ANNOUNCE_SITCOMMAND"))
		if not targ.components.unteleportable then targ:AddComponent("unteleportable") end
		targ.components.followersitcommand:SetStaying(true)
		targ.components.followersitcommand:RememberSitPos("currentstaylocation", GLOBAL.Point(targ.Transform:GetWorldPosition())) 
		targ.components.combat:GiveUp()
		return true
	end
end
ACTIONS.SITCOMMAND.str = STRINGS.ACTIONS.SITCOMMAND
ACTIONS.SITCOMMAND.id = "SITCOMMAND"

ACTIONS.SITCOMMAND_CANCEL = GLOBAL.Action(2, true, true)
ACTIONS.SITCOMMAND_CANCEL.fn = function(act)
	local targ = act.target
	if targ and targ.components.followersitcommand then
		act.doer.components.locomotor:Stop()
		act.doer.components.talker:Say(GLOBAL.GetString(act.doer.prefab, "ANNOUNCE_SITCOMMAND_CANCEL"))
		targ:RemoveComponent("unteleportable")
		targ.components.followersitcommand:SetStaying(false)
		return true
	end
end
ACTIONS.SITCOMMAND_CANCEL.str = STRINGS.ACTIONS.SITCOMMAND_CANCEL
ACTIONS.SITCOMMAND_CANCEL.id = "SITCOMMAND_CANCEL"	   
	   
function lootdropperpostinit(inst)

	inst.GenerateLoot = function(self)
    local loots = {}
    
    if self.numrandomloot and math.random() <= (self.chancerandomloot or 1) then
		for k = 1, self.numrandomloot do
		    local loot = self:PickRandomLoot()
		    if loot then
			    table.insert(loots, loot)
			end
		end
	end
    
    if self.chanceloot then
		for k,v in pairs(self.chanceloot) do
			if math.random() < v.chance then
				table.insert(loots, v.prefab)
				self.droppingchanceloot = true
			end
		end
	end

    if self.chanceloottable then
    	local loot_table = GLOBAL.LootTables[self.chanceloottable]
    	if loot_table then
    		for i, entry in ipairs(loot_table) do
    			local prefab = entry[1]
    			local chance = entry[2]    			
				if math.random() <= chance then
					table.insert(loots, prefab)
					self.droppingchanceloot = true
				end
			end
		end
	end

	if not self.droppingchanceloot and self.ifnotchanceloot then
		self.inst:PushEvent("ifnotchanceloot")
		for k,v in pairs(self.ifnotchanceloot) do
			table.insert(loots, v.prefab)
		end
	end


    
    if self.loot then
		for k,v in ipairs(self.loot) do
			table.insert(loots, v)
		end
	end
	
	local recipe = GLOBAL.GetRecipe(self.inst.prefab)

	if recipe and not self.inst.components.norecipelootdrop then
	

		
		local percent = 1

		if self.inst.components.finiteuses then
			percent = self.inst.components.finiteuses:GetPercent()
		end

		for k,v in ipairs(recipe.ingredients) do
			local amt = math.ceil( (v.amount * TUNING.HAMMER_LOOT_PERCENT) * percent)
			for n = 1, amt do
				table.insert(loots, v.type)
			end
		end
	end
    
    return loots

    end


end	   
	   
local function Pumpkin_Lord( inst )

	inst:DoTaskInTime( 0, function() 
		local controls = inst.HUD.controls
		local Pumpkin_Lord_Health = require "widgets/pumpkin_lord_health"
		controls.petStatus = controls:AddChild(Pumpkin_Lord_Health(inst))
		controls.petStatus:SetPosition(0, -250, 0)
	end)

end	   

AddSimPostInit( Pumpkin_Lord )	  

AddComponentPostInit("lootdropper", lootdropperpostinit)


