	local brain = require "brains/pumpkin_lordbrain"

	
local assets =
{

		Asset("ANIM", "anim/player_basic.zip"),
        Asset("ANIM", "anim/player_idles_shiver.zip"),
        Asset("ANIM", "anim/player_actions.zip"),
        Asset("ANIM", "anim/player_actions_axe.zip"),
        Asset("ANIM", "anim/player_actions_pickaxe.zip"),
        Asset("ANIM", "anim/player_actions_shovel.zip"),
        Asset("ANIM", "anim/player_actions_blowdart.zip"),
        Asset("ANIM", "anim/player_actions_eat.zip"),
        Asset("ANIM", "anim/player_actions_item.zip"),
        Asset("ANIM", "anim/player_cave_enter.zip"),
        Asset("ANIM", "anim/player_actions_uniqueitem.zip"),
        Asset("ANIM", "anim/player_actions_bugnet.zip"),
        Asset("ANIM", "anim/player_actions_fishing.zip"),
        Asset("ANIM", "anim/player_actions_boomerang.zip"),
        Asset("ANIM", "anim/player_bush_hat.zip"),
        Asset("ANIM", "anim/player_attacks.zip"),
        Asset("ANIM", "anim/player_idles.zip"),
        Asset("ANIM", "anim/player_rebirth.zip"),
        Asset("ANIM", "anim/player_jump.zip"),
        Asset("ANIM", "anim/player_amulet_resurrect.zip"),
		Asset("ANIM", "anim/player_teleport.zip"),
        Asset("ANIM", "anim/wilson_fx.zip"),
        Asset("ANIM", "anim/player_one_man_band.zip"),
        Asset("ANIM", "anim/player_slurtle_armor.zip"),
        Asset("ANIM", "anim/player_staff.zip"),
        Asset("ANIM", "anim/pumpkin_guard.zip"),
		
	    Asset("ATLAS", "images/inventoryimages/pumpkin_lord.xml"),
	    Asset("IMAGE", "images/inventoryimages/pumpkin_lord.tex"),	
        

		Asset("ANIM", "anim/shadow_hands.zip"),

        Asset("SOUND", "sound/sfx.fsb"),
        Asset("SOUND", "sound/wilson.fsb"),
}

--local prefabs =
--{
-- "emerald",
--}


local function ondeath(inst)
	local player = GetPlayer()
	if player then
        inst.SoundEmitter:PlaySound("dontstarve/creatures/werepig/death")
		local pt = inst:GetPosition()
	end
end

 local function regen(inst, dt)
    inst.regen_time = inst.regen_time - dt  
	 
      if inst.regen_time <= 0 then
        inst.regen_time = 3
		inst.components.health:DoDelta(20)
      end
end

local function fn(Sim)
    
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	local whoisplayer = GetPlayer()
	

	shadow:SetSize( 1.5, .75 )
    inst.Transform:SetFourFaced()
	
    MakeCharacterPhysics(inst, 30, .3)
	
	
	inst:DoPeriodicTask(1/10, function() regen(inst, 1/10) end)
	inst.regen_time = 3
	
	
	inst:AddTag("pumpkin_lord")
    inst:AddTag("sheltercarrier")
    inst:AddTag("summonedbyplayer")
    inst:AddTag("scarytoprey")
	inst:AddTag("notraptrigger")

	anim:SetBank("pigman")
	anim:SetBuild("pumpkin_guard")

    inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
    inst.components.locomotor.runspeed = 7
    inst.components.locomotor.walkspeed = 7
    
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(900)
	inst:ListenForEvent("death", ondeath)
	inst.components.health.fire_damage_scale = 2 
    
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(46)
    inst.components.combat:SetAttackPeriod(2)

    inst:AddComponent("follower")
    inst.components.follower.maxfollowtime = 99999999
    whoisplayer.components.leader:AddFollower(inst)
    inst.components.follower:AddLoyaltyTime(9999999)

    inst:AddComponent("talker")
    inst.components.talker:StopIgnoringAll()

    inst:AddComponent("inspectable")
    local minimap = inst.entity:AddMiniMapEntity()  
    minimap:SetIcon( "pumpkin_lord.tex" )        
   
    inst:SetBrain(brain)

    if ACTIONS.SITCOMMAND ~= nil then
    	inst:AddComponent("followersitcommand")
    end

    inst:AddComponent("lootdropper")
    inst:AddComponent("norecipelootdrop")

	inst:AddComponent("talker")          -- he can speak
    inst.components.talker.fontsize = 35
    inst.components.talker.colour = Vector3(115/255, 200/255, 115/255)
	
    inst.AnimState:Hide("ARM_carry") 
    inst.AnimState:Show("ARM_normal") 

    inst:SetStateGraph("SGpumpkin_lord")
   
    return inst
end

STRINGS.NAMES.PUMPKIN_LORD							        = "Pumpkin guard"
STRINGS.RECIPE_DESC.PUMPKIN_LORD 							= "Mix magic, pumpkin and grass!"

STRINGS.CHARACTERS.GENERIC.DESCRIBE.PUMPKIN_LORD 			= "Fight for me, living pumpkin!"
STRINGS.CHARACTERS.WILLOW.DESCRIBE.PUMPKIN_LORD 			= "He is strong, but he's easy to burn."
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.PUMPKIN_LORD 			= "Not that strong as Wolfgang!"
STRINGS.CHARACTERS.WENDY.DESCRIBE.PUMPKIN_LORD 				= "I sense unknown dark energy."
STRINGS.CHARACTERS.WX78.DESCRIBE.PUMPKIN_LORD 				= "VEGGIE MINION READY FOR BATTLE"
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.PUMPKIN_LORD 		= "Interesting. I've never seen such aggressive vegetable."
STRINGS.CHARACTERS.WOODIE.DESCRIBE.PUMPKIN_LORD 			= "My wooden servant. Too bad he can't chop with me."
STRINGS.CHARACTERS.WAXWELL.DESCRIBE.PUMPKIN_LORD 			= "Another mindless servant willing to die for me."

if IsDLCEnabled(REIGN_OF_GIANTS) then
	STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.PUMPKIN_LORD 	= "Good warrior by my side!"
	STRINGS.CHARACTERS.WEBBER.DESCRIBE.PUMPKIN_LORD 		= "We fear that he will turn against us."
end

if IsDLCEnabled(CAPY_DLC) then 
	STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.PUMPKIN_LORD		= "Arrr! Fight!"
	STRINGS.CHARACTERS.WALANI.DESCRIBE.PUMPKIN_LORD			= "He looks quite spooky!"
	STRINGS.CHARACTERS.WARLY.DESCRIBE.PUMPKIN_LORD			= "I hope that pumpkin is not wasted."
end

return Prefab("common/pumpkin_lord", fn, assets, prefabs)